#include "calendar.h"
#include "subprogram.h"

class Event {
	public:
		string title;
		int month;
		int day;
		int year;
		int hour;
		string event;
		string note[5];
		void clear() 
		{
			int count;
			
			month = -1;
			day = 0;
			year = 0;
			event = "";
			
			for (count = 0; count < 5; count++) {
				note[count] = "";
			}
		}
		
	private:
};

string dayList[24] = { "12:00 am", "1:00 am", "2:00 am", "3:00 am", "4:00 am", "5:00 am", "6:00 am",
						"7:00 am", "8:00 am", "9:00 am", "10:00 am", "11:00 am", "12:00 pm", "1:00 pm",
						"2:00 pm", "3:00 pm", "4:00 pm", "5:00 pm", "6:00 pm", "7:00 pm", "8:00 pm",
						"9:00 pm", "10:00 pm", "11:00 pm" };

extern SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *screen;
extern SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys;
extern SDL_Surface *img_textbackground, *tmp, *img_view, *img_test, *im_screen, *img_menubar;
extern SDL_Color sdlwhite;
extern SDL_Color sdlblack;
extern SDL_Color sdlgrey;
extern SDL_Color sdldarkgrey;
extern SDL_Color sdlred;
extern SDL_Color sdlgreen;
extern SDL_Color sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;
extern TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *systemfont;
extern int nCol, nLine, nMaxinput; 

extern bool bmUpdate, btest, isplaying;
extern bool transition, padrelease;
extern int wait,nCol, nLine, menumode, menu, menucursor, blx, bly, blh;
extern SceCtrlData pad;

int calendar[6][7];
int eventcalendar[6][7];
int mx = 0, my = 0, dday, dmonth, dyear, month, year, hourscroll = -6, hourselect = 6, hourcursor = 0;
int gmonth, gyear[4];
static int inputcursor, entry, eventselect, cscroll, cselect, ccursor, cmaxlines = 5;
vector <Event> eventList;
vector <Event> monthevents;
vector <Event> weekevents;
vector <Event> dayevents;
Event event;
string title;

void initCalendar(int cday, int cmon, int cyear) {
	dday = cday;
	dmonth = cmon;
	dyear = cyear;
	loadCalendar();
	mx = 0;
	my = 0;
	hourscroll = -6;
	hourselect = 6;
	hourcursor = 0;	
	setWeek();
}

void loadCalendar(void) {
	ifstream file("calendar.dat");
	string readline;
	int entry=0, loc;
	Event event;
	eventList.clear();
	
	while (getline(file,readline,'\n')) {
		loc = readline.find((char) 13,0);
		if (loc != string::npos) readline.resize(readline.size()-1);
		if (entry == 0) event.title = readline;
		if (entry == 1) event.month = atoi(readline.c_str());
		if (entry == 2) event.day = atoi(readline.c_str());
		if (entry == 3) event.year = atoi(readline.c_str());
		if (entry == 4) event.hour = atoi(readline.c_str());
		if (entry == 5) event.event = readline;
		if (entry == 6) event.note[0] = readline;
		if (entry == 7) event.note[1] = readline;
		if (entry == 8) event.note[2] = readline;
		if (entry == 9) event.note[3] = readline;
		if (entry == 10) event.note[4] = readline;
		entry++;
		if (entry == 11) {
			entry = 0;
			eventList.push_back(event);
		}
	}
	file.close();
}

void saveCalendar(void) {
	ofstream writefile;
	int count;
	
	setWeek();
	writefile.open("calendar.dat");
	for (count = 0; count < eventList.size(); count++) {		
		writefile << eventList[count].title << endl;
		writefile << eventList[count].month << endl;
		writefile << eventList[count].day << endl;
		writefile << eventList[count].year << endl;
		writefile << eventList[count].hour << endl;
		writefile << eventList[count].event << endl;
		writefile << eventList[count].note[0] << endl;
		writefile << eventList[count].note[1] << endl;
		writefile << eventList[count].note[2] << endl;
		writefile << eventList[count].note[3] << endl;
		writefile << eventList[count].note[4] << endl;		
	}
	writefile.close();
}

void displayCalendar(SDL_Surface* surface) {
	int count, cy, cx;
	char daystring[2];
	string monthname;
	char sizestring[10];
	
	monthname = getMonth(month);
	sprintf(sizestring," %d",year);
	monthname = monthname + sizestring;
	drawFillRect(surface,0,0,480,272,backcol);
	if (img_test) blit(surface,0,0,img_test);
	
	
//------------------------
	drawText(drawfont16,surface,241-monthname.size()*5,21,monthname,sdlgrey);
	drawHline(surface,101,39,280,grey);
	drawText(font,surface,103,39,"Sun",sdlgrey);
	drawText(font,surface,143,39,"Mon",sdlgrey);
	drawText(font,surface,183,39,"Tue",sdlgrey);
	drawText(font,surface,223,39,"Wed",sdlgrey);
	drawText(font,surface,263,39,"Thu",sdlgrey);
	drawText(font,surface,303,39,"Fri",sdlgrey);
	drawText(font,surface,343,39,"Sat",sdlgrey);
	
	for (count = 0; count < 7; count++) {
		//drawHline(surface,101, 51+count*33, 280,grey);
	}
	
	for (count = 0; count < 8; count++) {
		drawVline(surface,101 + count*40,39, 211,grey);
	}
	
	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			sprintf(daystring,"%d",calendar[cy][cx]);
			if (calendar[cy][cx] != 0 && eventcalendar[cy][cx] != 0) {
				if (calendar[cy][cx] == dday && month == dmonth && year == dyear)	{
					drawFillRect(surface, 100+cx*40, 50+cy*33, 40, 33, blue);
				}
			}			
			if (calendar[cy][cx] != 0) drawText(font,surface,103 + cx*40, 53+cy*33,daystring,sdlgrey);
		}
	}
//-----------------------------------	
	drawText(drawfont16,surface,239-monthname.size()*5,19,monthname,sdlgrey);
	drawHline(surface,99,37,280,grey);
	drawText(font,surface,101,37,"Sun",sdlgrey);
	drawText(font,surface,141,37,"Mon",sdlgrey);
	drawText(font,surface,181,37,"Tue",sdlgrey);
	drawText(font,surface,221,37,"Wed",sdlgrey);
	drawText(font,surface,261,37,"Thu",sdlgrey);
	drawText(font,surface,301,37,"Fri",sdlgrey);
	drawText(font,surface,341,37,"Sat",sdlgrey);
	
	for (count = 0; count < 7; count++) {
		drawHline(surface,99, 49+count*33, 280,grey);
	}
	
	for (count = 0; count < 8; count++) {
		drawVline(surface,99 + count*40,37, 211,grey);
	}
	
	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			sprintf(daystring,"%d",calendar[cy][cx]);
			if (calendar[cy][cx] != 0) drawText(font,surface,101 + cx*40, 51+cy*33,daystring,sdlgrey);
		}
	}
//------------------------

	drawText(drawfont16,surface,239-monthname.size()*5,21,monthname,sdlgrey);
	drawHline(surface,99,39,280,grey);
	drawText(font,surface,101,39,"Sun",sdlgrey);
	drawText(font,surface,141,39,"Mon",sdlgrey);
	drawText(font,surface,181,39,"Tue",sdlgrey);
	drawText(font,surface,221,39,"Wed",sdlgrey);
	drawText(font,surface,261,39,"Thu",sdlgrey);
	drawText(font,surface,301,39,"Fri",sdlgrey);
	drawText(font,surface,341,39,"Sat",sdlgrey);
	
	for (count = 0; count < 7; count++) {
		drawHline(surface,99, 51+count*33, 282,grey);
	}
	
	for (count = 0; count < 8; count++) {
		drawVline(surface,99 + count*40,39, 211,grey);
	}
	
	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			sprintf(daystring,"%d",calendar[cy][cx]);
			if (calendar[cy][cx] != 0) drawText(font,surface,101 + cx*40, 53+cy*33,daystring,sdlgrey);
		}
	}
//---------------------------------

	drawText(drawfont16,surface,241-monthname.size()*5,19,monthname,sdlgrey);
	drawHline(surface,101,37,280,grey);
	drawText(font,surface,103,37,"Sun",sdlgrey);
	drawText(font,surface,143,37,"Mon",sdlgrey);
	drawText(font,surface,183,37,"Tue",sdlgrey);
	drawText(font,surface,223,37,"Wed",sdlgrey);
	drawText(font,surface,263,37,"Thu",sdlgrey);
	drawText(font,surface,303,37,"Fri",sdlgrey);
	drawText(font,surface,343,37,"Sat",sdlgrey);
	
	for (count = 0; count < 7; count++) {
		drawHline(surface,101, 49+count*33, 280,grey);
	}
	
	for (count = 0; count < 8; count++) {
		drawVline(surface,101 + count*40,37, 211,grey);
	}
	
	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			sprintf(daystring,"%d",calendar[cy][cx]);
			if (calendar[cy][cx] != 0) drawText(font,surface,103 + cx*40, 51+cy*33,daystring,sdlgrey);
		}
	}
//-----------------------
	drawText(drawfont16,surface,240-monthname.size()*5,20,monthname,sdlblack);
	drawHline(surface,100,38,280,black);
	drawText(font,surface,102,38,"Sun",sdlblack);
	drawText(font,surface,142,38,"Mon",sdlblack);
	drawText(font,surface,182,38,"Tue",sdlblack);
	drawText(font,surface,222,38,"Wed",sdlblack);
	drawText(font,surface,262,38,"Thu",sdlblack);
	drawText(font,surface,302,38,"Fri",sdlblack);
	drawText(font,surface,342,38,"Sat",sdlblack);
	
	for (count = 0; count < 7; count++) {
		drawHline(surface,100, 50+count*33, 280,black);
	}
	
	for (count = 0; count < 8; count++) {
		drawVline(surface,100 + count*40,38, 211,black);
	}
	
	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			sprintf(daystring,"%d",calendar[cy][cx]);
			if (calendar[cy][cx] != 0 && eventcalendar[cy][cx] != 0) drawText(font,surface,102 + cx*40, 52+cy*33,daystring,sdlred);
			else if (calendar[cy][cx] == dday && month == dmonth && year == dyear) drawText(font,surface,102 + cx*40, 52+cy*33,daystring,sdlblue);
			else if (calendar[cy][cx] != 0) drawText(font,surface,102 + cx*40, 52+cy*33,daystring,sdlblack);
		}
	}
	
	drawRect(im_screen, 100 + mx*40, 50 + my*33, 40, 33, green);
	
}

void getCalendarInput(void) {
	Event tmpevent;
	int count;
	
	if (pad.Buttons & PSP_CTRL_UP || pad.Ly == 0) {
		if (my > 0) {
			my--;
			bmUpdate = true;
			wait = 120;
		}
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN || pad.Ly == 255) {
		if (my < 5) {
			my++;
			bmUpdate = true;
			wait = 120;
		}
	}
	
	if (pad.Buttons & PSP_CTRL_LEFT || pad.Lx == 0) {
		if (mx > 0) {
			mx--;
			bmUpdate = true;
			wait = 120;
		}
	}
	
	if (pad.Buttons & PSP_CTRL_RIGHT || pad.Lx == 255) {
		if (mx < 6) {
			mx++;
			bmUpdate = true;
			wait = 120;	
		}
	}
	
	if (pad.Buttons & PSP_CTRL_RTRIGGER && !transition) {
		if (month == 12) {
			month = 1;
			year++;
		}
		else month++;
		setCalendar(month,year);		
		wait = 120;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_LTRIGGER) {
		if (month == 1) {
			month = 12;
			year--;
		}
		else month--;
		setCalendar(month,year);			
		wait = 120;
		bmUpdate = true;
	}	
	
	if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
		if (calendar[my][mx] > 0) {
			menumode = 15;
			bmUpdate = true;
			transition = true;
			
			tmpevent.clear();
			dayevents.clear();
			
			for (count = 0; count < 24; count++) {
				dayevents.push_back(tmpevent);
			}
			
			for (count = 0; count < monthevents.size(); count++) {
				if (calendar[my][mx] == monthevents[count].day && month == monthevents[count].month && year == monthevents[count].year) {
					dayevents[monthevents[count].hour] = monthevents[count];
				}
			}			
		}
	}
}

void getCalendarDayInput(void) 
{
	char sizestring[50];
	int count;
	string readkey;
	char echar[20], elchar[20];
	int estring, elstring;	

	
	if (menumode == 15) {
	
		if (pad.Buttons & PSP_CTRL_UP) {
			if ((hourselect + hourscroll == 0) && hourselect > 0) hourscroll++;
			hourselect--;
			if (hourselect < 0) hourselect = 0;
			hourcursor--;
			if (hourcursor < 0) hourcursor = 0;
	
			wait = 120;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if ((hourselect + hourscroll == 10-1) && hourselect < 24-1) hourscroll--;
			hourselect++;
			if (hourselect == 24) hourselect = 24-1;
			hourcursor++;
			if (hourcursor == 10) hourcursor = 10-1;
			
			if (hourcursor == 24) hourcursor = 24-1;
	
			wait = 120;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
			sprintf(sizestring, "%s - %s, %s %d, %d", dayList[hourselect].c_str(), getDay(mx).c_str(), getMonth(month).c_str(), calendar[my][mx],year);
			title = sizestring;	
			
			count = 0;
			if (eventList.size() > 0) {
				while (title != eventList[count].title && count < eventList.size()) {
					count++;
					if (count == eventList.size()) break;
				}
			}
			if (count < eventList.size()) {
				event = eventList[count];
			}
			else {
				event.clear();
				event.title = title;
				event.month = month;
				event.day = calendar[my][mx];
				event.year = year;
				event.hour = hourselect;
			}
			entry = -1;
			inputcursor = event.event.size();
			menumode = 16;
			bmUpdate = true;
			transition = true;
			wait = 120;
		}
		
		if (pad.Buttons & PSP_CTRL_TRIANGLE) {
			if (dayevents[hourselect].event.size() > 0) {
				sprintf(sizestring, "%s - %s, %s %d, %d", dayList[hourselect].c_str(), getDay(mx).c_str(), getMonth(month).c_str(), calendar[my][mx],year);
				title = sizestring;	
				
				count = 0;
				if (eventList.size() > 0) {
					while (title != eventList[count].title && count < eventList.size()) {
						count++;
						if (count == eventList.size()) break;
					}
				}
				eventselect = count;
				menumode = 17;
				bmUpdate = true;
				wait = 120;
			}
		}
	}			
	
	
	if (menumode == 16) {
		if (padUp()) {
			if (entry == -1) entry = 5;
			else entry--;
			wait = 120;
			bmUpdate = true;
			if (entry == -1) inputcursor = event.event.size();
			else if (entry >= 0 && entry < 5) {
				inputcursor = event.note[entry].size();
				if (inputcursor < event.note[entry].size() - 1) {
					inputcursor = event.note[entry].size();
				}		
			}
		}
		if (padDown()) {
			if (entry == 5) entry = -1;
			else entry++;
			wait = 120;
			bmUpdate = true;
			if (entry == -1) inputcursor = event.event.size();
			else if (entry >= 0 && entry < 5) {
				inputcursor = event.note[entry].size();
				if (inputcursor < event.note[entry].size() - 1) {
					inputcursor = event.note[entry].size();
				}
			}
		}
		if (padLeft()) {
			if (inputcursor > 0) {
				inputcursor--;
				wait = 120;
				bmUpdate = true;
			}
		}
		
		if (padRight()) {
			if (entry == -1) count = event.event.size();
			else if (entry >= 0 && entry < 5) count = event.note[entry].size();
			if (inputcursor < count) {
				inputcursor++;
				wait = 120;
				bmUpdate = true;
			}		
		}	
		readKeyboard();
		readkey = readKey();
# ifdef USE_PSP_IRKEYB
  if (readkey == "ed") {
    return;
  }
# endif
		if (readkey != "") {
			if (readkey == "     ") {
				if (entry == -1) {
					entry = 0;
					inputcursor = event.note[entry].size();
				}
				else if (entry >= 0 && entry < 5) entry = 5;
				else {
					entry = -1;
					inputcursor = event.event.size();
				}
			}
			else if (readkey == "bs") {
				if (entry == -1) {
					if (inputcursor > 0 && event.event.size() > 0) {
						event.event.erase(inputcursor-1,1);
						inputcursor--;
					}
				}
				else if (entry >= 0 && entry < 5) {
					if (inputcursor > 0 && event.note[entry].size() > 0) {
						event.note[entry].erase(inputcursor-1,1);
						inputcursor--;
					}
				}
			}
			else if (readkey == "en") {
				if ((entry == -1 || entry == 5) && event.event.size() > 0) {
					if (eventList.size() == 0) {
						eventList.push_back(event);
					}
					else {
						count = 0;
						while (title != eventList[count].title && count < eventList.size()) {
							count++;
							if (count == eventList.size()) break;
						}
						if (count < eventList.size()) eventList.erase(eventList.begin() + count);
						count = 0;					
						
						sprintf(echar,"%d%02d%02d%02d",event.year,event.month,event.day,event.hour);
						sprintf(elchar,"%d%02d%02d%02d",eventList[count].year,eventList[count].month,eventList[count].day,eventList[count].hour);
						estring = atoi(echar);
						elstring = atoi(elchar);
						while (estring > elstring && count < eventList.size()) {
							count++;
							if (count == eventList.size()) break;
							sprintf(echar,"%d%02d%02d",event.year,event.month,event.day,event.hour);
							sprintf(elchar,"%d%02d%02d",eventList[count].year,eventList[count].month,eventList[count].day,eventList[count].hour);
							estring = atoi(echar);
							elstring = atoi(elchar);							
						}
						if (count == eventList.size()) eventList.push_back(event);
						else eventList.insert(eventList.begin()+count,event);
					}
					menumode = 0;
					saveCalendar();
					setCalendar(event.month,event.year);
					transition = true;
					inputcursor = 0;				
				}
				else {
					if (entry < 4) entry++;
					if (inputcursor < event.note[entry].size() - 1) {
						inputcursor = event.note[entry].size();
					}
					
				}
					
			}
			else  {
				if (entry == -1) {
					if (event.event.size() < 48) {
						event.event.insert(inputcursor,readkey);
						inputcursor++;
					}
				}
				else if (entry >= 0 && entry < 5) {
					if (event.note[entry].size() < 48) {
						event.note[entry].insert(inputcursor,readkey);
						inputcursor++;
					}
				}
			}
			bmUpdate = true;
		}
	}
	
	if (menumode == 17) {
		if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
			eventList.erase(eventList.begin()+eventselect);
			menumode = 0;
			saveCalendar();
			setCalendar(month,year);
			bmUpdate = true;
			transition = true;
			wait = 120;
		}
	}		
}

void displayCalendarDay(void) {
	char sizestring[50];
	string textscroll;
	int count, index;
	Event tmpevent;
	
	tmpevent.clear();

	
	if (menumode == 15) 
	{
		
		sprintf(sizestring, "%s, %s %d, %d", getDay(mx).c_str(), getMonth(month).c_str(), calendar[my][mx],year);
		title = sizestring;
		drawMenuFrame(im_screen);
		drawText(font,im_screen,240-title.size()*nCol/2,17,title, sdlblack);
		
		drawText(systemfont,im_screen,30,161,"Edit/View:         Delete:",sdlblack);
		drawText(systemfont,im_screen,30,161,"           Cross           Triangle",sdlblue);	
				
		
		for (count = 0; count < 10; count++)
		{
			drawHline(im_screen, 100, 45 + count*nLine, 336, lightgrey);
		}		
		
		for (count = 0; count < 24; count++) 
		{
			if (hourselect == count) 
			{
				drawFillRect(im_screen,34,35+hourcursor*nLine - 1, 1+dayList[count].size() * nCol, nLine, grey);
			}
			if ((hourscroll*nLine + count*nLine) < 120 && (hourscroll*nLine + count*nLine) >= 0) 
			{
				drawText(font,im_screen,35,35+hourscroll*nLine+count*nLine, dayList[count], sdldarkgrey);
				drawText(font,im_screen,100,35+hourscroll*nLine+count*nLine, dayevents[count].event, sdlblack);
			}
		}
		blx = 0;
	}
	
	if (menumode == 16) {
		drawKeyboard(im_screen);
		drawMenuFrame(im_screen);
		drawText(font,im_screen,240-title.size()*nCol/2,17,title, sdlblack);
		
		//drawFillRect(im_screen,176,46,260,16,white);		
		if (entry != -1) drawFillRect(im_screen,98,46,342,16,lightgrey);
		drawRect(im_screen,99,47,342,16,black);
		drawRect(im_screen,98,46,342,16,grey);
		
		//drawFillRect(im_screen,176,66,260,16,grey);
		if (entry == -1 || entry == 5) drawFillRect(im_screen,98,66,342,64,lightgrey);
		drawRect(im_screen,99,67,342,64,black);
		drawRect(im_screen,98,66,342,64,grey);
		
		if (entry == 5) {
			drawFillRect(im_screen,38,138,32,16,blue);
			drawText(font,im_screen,40, 140, "Save",sdlwhite);
			drawText(systemfont,im_screen,30,161,"Press Tab to modify Event.  Press Enter when done",sdlblue);
		}
		else drawText(font,im_screen,40, 140, "Save",sdlblack);
		
		drawRect(im_screen,39,139,32,16,black);
		drawRect(im_screen,38,138,32,16,grey);
		
		drawText(font,im_screen,40, 50, "Event:",sdlblack);
		drawText(font,im_screen,40, 70, "Note:",sdlblack);
		

		drawText(font,im_screen,100, 50, event.event, sdlblack);
		if (entry == -1) {
			blx = 100+inputcursor*nCol;
			bly = 48;
			blh = nLine;
			drawText(systemfont,im_screen,30,161,"Press Tab to modify Note.  Press Enter when done",sdlblue);
		}
		
		for (count = 0; count < 5; count++) {
			drawText(font,im_screen,100, 70+count*nLine, event.note[count], sdlblack);
		}
		
		
		
		if (entry >= 0 && entry < 5) {
			blx = 100+inputcursor*nCol;
			bly = 68+entry*nLine;
			blh = nLine;
			drawText(systemfont,im_screen,30,161,"Press Tab to save.",sdlblue);
		}
	}
	
	if (menumode == 17) {
		drawMenuFrame(im_screen);
		
		drawFillRect(im_screen,176,46,260,16,grey);
		drawRect(im_screen,177,47,260,16,black);
		drawRect(im_screen,176,46,260,16,grey);

		drawText(font,im_screen, 40, 50, "Delete Event:",sdlblack);
		
		if (eventList[eventselect].event.size() > nMaxinput) textscroll = eventList[eventselect].event.substr(eventList[eventselect].event.size()-nMaxinput);
		else textscroll = eventList[eventselect].event;
		drawText(font,im_screen,180,50, textscroll.c_str(), sdlblack);
		
		drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
		drawText(font,im_screen,40,140, "Press Cross to delete", sdlblue);
		drawText(font,im_screen,194,17,"OK to delete?", sdlblack);
		blx = 0;
	}	

}

void getGotoMonthInput(void)
{
	if (pad.Buttons & PSP_CTRL_LEFT)
	{
		if (entry == 1) entry = 5;
		else entry--;
		bmUpdate = true;
		wait = 120;
	}
	
	if (pad.Buttons & PSP_CTRL_RIGHT)
	{
		if (entry == 5) entry = 1;
		else entry++;
		bmUpdate = true;
		wait = 120;
	}
	
	if (pad.Buttons & PSP_CTRL_UP)
	{
		if (entry == 1)
		{
			if (gmonth == 12) gmonth = 1;
			else gmonth++;			
		}
		else 
		{
			if (gyear[entry-2] == 9) gyear[entry-2] = 0;
			else gyear[entry-2]++;
		}
		bmUpdate = true;
		wait = 120;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN)
	{
		if (entry == 1)
		{
			if (gmonth == 1) gmonth = 12;
			else gmonth--;			
		}
		else 
		{
			if (gyear[entry-2] == 0) gyear[entry-2] = 9;
			else gyear[entry-2]--;
		}
		bmUpdate = true;
		wait = 120;
	}

	if (pad.Buttons & PSP_CTRL_CROSS && padrelease)
	{
		month = gmonth;
		char cstring[5];		
		sprintf(cstring,"%d%d%d%d",gyear[0],gyear[1],gyear[2],gyear[3]);
		year = atoi(cstring);
		setCalendar(month,year);
		bmUpdate = true;
		padrelease = false;
		transition = true;
		menumode = 0;
	}
}

void displayGotoMonth(void)
{
	char cstring[20];
	string str;
	int xpos;
	
	drawMenuFrame(im_screen);	
	
	drawFillRect(im_screen,176,46,260,16,white);

	drawText(font,im_screen, 40, 50, "Month:",sdlblack);
	str = getMonth(gmonth);
	if (entry == 1) drawText(font,im_screen, 92, 50, str, sdlblue);
	else drawText(font,im_screen, 92, 50, str, sdlblack);
	
	drawText(font,im_screen,240, 50, "Year:",sdlblack);
	
	xpos = 285;
	sprintf(cstring,"%d",gyear[0]);
	if (entry == 2) drawText(font,im_screen, xpos, 50, cstring, sdlblue);
	else drawText(font,im_screen, xpos, 50, cstring, sdlblack);
	
	sprintf(cstring," %d",gyear[1]);
	if (entry == 3) drawText(font,im_screen, xpos, 50, cstring, sdlblue);
	else drawText(font,im_screen, xpos, 50, cstring, sdlblack);
	
	sprintf(cstring,"  %d",gyear[2]);
	if (entry == 4) drawText(font,im_screen, xpos, 50, cstring, sdlblue);
	else drawText(font,im_screen, xpos, 50, cstring, sdlblack);
	
	sprintf(cstring,"   %d",gyear[3]);
	if (entry == 5) drawText(font,im_screen, xpos, 50, cstring, sdlblue);
	else drawText(font,im_screen, xpos, 50, cstring, sdlblack);
	
	drawText(font,im_screen,40,120, "Press Select to cancel", sdlblue);
	drawText(font,im_screen,40,140, "Press Cross when done", sdlblue);
	drawText(font,im_screen,205,17,"Goto Month", sdlblack);
	blx = 0;
}

void getWeekEventsInput(void)
{
	int count;
	
	if (pad.Buttons & PSP_CTRL_UP) {
		if ((cselect + cscroll == 0) && cselect > 0) cscroll++;
		cselect--;
		if (cselect < 0) cselect = 0;
		ccursor--;
		if (ccursor < 0) ccursor = 0;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if ((cselect + cscroll == cmaxlines-1) && cselect < weekevents.size()-1) cscroll--;
		cselect++;
		if (cselect == weekevents.size()) cselect = weekevents.size()-1;
		ccursor++;
		if (ccursor == cmaxlines) ccursor = cmaxlines-1;
		
		if (ccursor == weekevents.size()) ccursor = weekevents.size()-1;

		wait = 100;
		bmUpdate = true;
	}

	if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
		title = weekevents[cselect].title;
		count = 0;
		if (eventList.size() > 0) {
			while (weekevents[cselect].title != eventList[count].title && count < eventList.size()) {
				count++;
				if (count == eventList.size()) break;
			}
		}
		if (count < eventList.size()) {
			event = eventList[count];
		}
		else {
			event.clear();
			event.title = title;
			event.month = month;
			event.day = calendar[my][mx];
			event.year = year;
			event.hour = hourselect;
		}
		entry = -1;
		inputcursor = event.event.size();
		menumode = 16;
		bmUpdate = true;
		transition = true;
		wait = 120;
	}
	
	if (pad.Buttons & PSP_CTRL_TRIANGLE) {
		if (weekevents[cselect].event.size() > 0) {
			
			count = 0;
			if (eventList.size() > 0) {
				while (weekevents[cselect].title != eventList[count].title && count < eventList.size()) {
					count++;
					if (count == eventList.size()) break;
				}
			}
			eventselect = count;
			menumode = 17;
			bmUpdate = true;
			wait = 120;
		}
	}	
}
void displayWeekEvents(void)
{
	int count;
	string textscroll, sstring;
	char cstring[50];
	
	drawMenuFrame(im_screen);
	drawText(systemfont,im_screen,30,161,"Edit/View:         Delete:",sdlblack);
	drawText(systemfont,im_screen,30,161,"           Cross           Triangle",sdlblue);
	
	sprintf(cstring,"%s %d",getMonth(dmonth).c_str(), dyear);
	textscroll = cstring;
	drawText(font,im_screen,240-textscroll.size()*7/2,17,textscroll, sdlblack);
	
	for (count = 0; count < 10; count++)
	{
		drawHline(im_screen, 35, 45 + count*nLine, 413, lightgrey);
	}
	for (count = 0; count < weekevents.size(); count++) 
	{
		if (weekevents[count].event.size() > 59) 
		{
			textscroll = weekevents[count].event.substr(0,59);
		}
		else 
		{
			textscroll = weekevents[count].event;
		}
		if (cselect == count) 
		{
			drawFillRect(im_screen,99,47+2*ccursor*nLine - 1, 1+textscroll.size() * nCol, nLine, grey);
		}
		if ((cscroll*nLine + 2*count*nLine) < 120 && (cscroll*nLine + 2*count*nLine) >= 0) 
		{
			sprintf(cstring,"%s %d %s", getDay(weekDay(weekevents[count].day,month,year)).c_str(), weekevents[count].day, dayList[monthevents[count].hour].c_str());
			sstring = cstring;
			drawText(font,im_screen,35,35+cscroll*nLine+2*count*nLine, sstring, sdlblack);
			drawText(font,im_screen,100,47+cscroll*nLine+2*count*nLine, textscroll, sdlblack);
		}
	}
	blx = 0;
}
void getMonthEventsInput(void)
{
	int count;
	
	if (pad.Buttons & PSP_CTRL_UP) {
		if ((cselect + cscroll/2 == 0) && cselect > 0) cscroll+=2;
		cselect--;
		if (cselect < 0) cselect = 0;
		ccursor--;
		if (ccursor < 0) ccursor = 0;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if ((cselect + cscroll/2 == cmaxlines-1) && cselect < monthevents.size()-1) cscroll-=2;
		cselect++;
		if (cselect == monthevents.size()) cselect = monthevents.size()-1;
		ccursor++;
		if (ccursor == cmaxlines) ccursor = cmaxlines-1;
		
		if (ccursor == monthevents.size()) ccursor = monthevents.size()-1;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
		title = monthevents[cselect].title;
		count = 0;
		if (eventList.size() > 0) {
			while (monthevents[cselect].title != eventList[count].title && count < eventList.size()) {
				count++;
				if (count == eventList.size()) break;
			}
		}
		if (count < eventList.size()) {
			event = eventList[count];
		}
		else {
			event.clear();
			event.title = title;
			event.month = month;
			event.day = calendar[my][mx];
			event.year = year;
			event.hour = hourselect;
		}
		entry = -1;
		inputcursor = event.event.size();
		menumode = 16;
		bmUpdate = true;
		transition = true;
		wait = 120;
	}
	
	if (pad.Buttons & PSP_CTRL_TRIANGLE) {
		if (monthevents[cselect].event.size() > 0) {
			
			count = 0;
			if (eventList.size() > 0) {
				while (monthevents[cselect].title != eventList[count].title && count < eventList.size()) {
					count++;
					if (count == eventList.size()) break;
				}
			}
			eventselect = count;
			menumode = 17;
			bmUpdate = true;
			wait = 120;
		}
	}		
}
void displayMonthEvents(void)
{
	int count;
	string textscroll, sstring;
	char cstring[50];
	
	drawMenuFrame(im_screen);
	drawText(systemfont,im_screen,30,161,"Edit/View:         Delete:",sdlblack);
	drawText(systemfont,im_screen,30,161,"           Cross           Triangle",sdlblue);
	
	sprintf(cstring,"%s %d",getMonth(month).c_str(), year);
	textscroll = cstring;
	drawText(font,im_screen,240-textscroll.size()*7/2,17,textscroll, sdlblack);
	
	for (count = 0; count < 10; count++)
	{
		drawHline(im_screen, 35, 45 + count*nLine, 413, lightgrey);
	}
	for (count = 0; count < monthevents.size(); count++) 
	{
		if (monthevents[count].event.size() > 59) 
		{
			textscroll = monthevents[count].event.substr(0,59);
		}
		else 
		{
			textscroll = monthevents[count].event;
		}
		if (cselect == count) 
		{
			drawFillRect(im_screen,99,47+2*ccursor*nLine - 1, 1+textscroll.size() * nCol, nLine, grey);
		}
		if ((cscroll*nLine + 2*count*nLine) < 120 && (cscroll*nLine + 2*count*nLine) >= 0) 
		{
			sprintf(cstring,"%s %d %s", getDay(weekDay(monthevents[count].day,month,year)).c_str(), monthevents[count].day, dayList[monthevents[count].hour].c_str());
			sstring = cstring;
			drawText(font,im_screen,35,35+cscroll*nLine+2*count*nLine, sstring, sdlblack);
			drawText(font,im_screen,100,47+cscroll*nLine+2*count*nLine, textscroll, sdlblack);
		}
	}
	blx = 0;
}

void getCalendarMenuInput(void) {

	if (menu == 7)
	{	
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_RIGHT) {
				menu = 1;
				menucursor = 1;
				wait = 100;
				padrelease = false;
				bmUpdate = true;
			}
			
			if (pad.Buttons & PSP_CTRL_LEFT) {
				menu = 4;
				menucursor = 1;
				wait = 100;
				padrelease = false;
				bmUpdate = true;
			}
		}
	
		
		if (pad.Buttons & PSP_CTRL_UP) {
			if (menucursor == 1) menucursor = 3;
			else menucursor--;
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (menucursor == 3) menucursor = 1;
			else menucursor++;
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_CROSS)
		{
			if (menucursor == 1)
			{
				char cstring[5];
				string str;
				sprintf(cstring,"%d", year);
				gmonth = month;
				str = cstring[0];
				gyear[0] = atoi(str.c_str());
				str = cstring[1];
				gyear[1] = atoi(str.c_str());
				str = cstring[2];
				gyear[2] = atoi(str.c_str());
				str = cstring[3];
				gyear[3] = atoi(str.c_str());							
				menumode = GOTOMONTH;
				entry = 1;
			}
			if (menucursor == 2)
			{
				cselect = 0;
				ccursor = 0;
				cscroll = 0;			
				menumode = WEEKEVENTS;				
			}
			if (menucursor == 3)
			{
				cselect = 0;
				ccursor = 0;
				cscroll = 0;			
				menumode = MONTHEVENTS;
			}			
			menu = 0;
			bmUpdate = true;
			padrelease = false;			
		}
	}
}	

void displayCalendarMenu(void)
{

		int menupos;
		
		blit(im_screen, 0,0, img_menubar);
		if (menu == 1) {
			drawFillRect(im_screen,8,0,32,10,darkgrey);
		}
		if (menu == 3) {
			drawFillRect(im_screen,58,0,32,10,darkgrey);
		}
		if (menu == 4) {
			drawFillRect(im_screen,108,0,39,10,darkgrey);
		}	
		if (menu == 7) {
			drawFillRect(im_screen,158,0,60,10,darkgrey);
		}
		drawText(font,im_screen,11,0, "File", sdlblack);
		drawText(font,im_screen,61,0, "View", sdlblack);
		if (isplaying) drawText(font,im_screen,111,0, "Music", sdlblack);
		else drawText(font,im_screen,111,0, "Music", sdldarkgrey);	
		drawText(font,im_screen,161,0, "Calendar", sdlblack);
	
		if (menu == 7) {
			menupos = 160;
			
			drawText(font,im_screen,menupos,0, "Calendar", sdlwhite);
	
			drawDropmenu(im_screen, menupos, 11, 17, 3);
			
			drawFillRect(im_screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*17-8, nLine, blue);
			
			if (menucursor == 1) {
				drawTextShadowed(font,im_screen,menupos+20,nLine+4, "Goto Month", sdlwhite);
			}
			else {
				drawText(font,im_screen,menupos+20,nLine+4, "Goto Month", sdlblack);
			}
			if (menucursor == 2) {
				drawTextShadowed(font,im_screen,menupos+20,2*nLine+4, "View Week Events", sdlwhite);
			}
			else {
				drawText(font,im_screen,menupos+20,2*nLine+4, "View Week Events", sdlblack);
			}
			if (menucursor == 3) {
				drawTextShadowed(font,im_screen,menupos+20,3*nLine+4, "View Month Events", sdlwhite);
			}
			else {
				drawText(font,im_screen,menupos+20,3*nLine+4, "View Month Events", sdlblack);
			}
		}	
	
}

void setWeek(void)
{
	int count, aday, bday;
	
	aday = dday - weekDay(dday, dmonth, dyear);
	if (aday < 1) aday = 1;
	
	bday = dday + 6 - weekDay(dday, dmonth, dyear);
	if (bday > getNumDays(dmonth, dyear)) bday = getNumDays(dmonth, dyear);
	
	weekevents.clear();
				
	for (count = 0; count < eventList.size(); count++) {
		if (dmonth == eventList[count].month && dyear == eventList[count].year && aday <= eventList[count].day && eventList[count].day <= bday) {
			weekevents.push_back(eventList[count]);
		}
	}	
}
	

void setCalendar(int mon, int yr) {
	bool first;
	int wd,md,count,cx,cy,index;
	char sizestring[10];
	
	month = mon;
	year = yr;
	wd = weekDay(1,month,year);
	md = getNumDays(month,year);
	
	monthevents.clear();

	
	for (count = 0; count < eventList.size(); count++) {
		if (month == eventList[count].month && year == eventList[count].year) {
			monthevents.push_back(eventList[count]);
		}
	}
	
	if (btest) SDL_FreeSurface(img_test);
	sprintf(sizestring,"calendar/%d.jpg",month);
	img_test=IMG_Load(sizestring);
	if (img_test) btest = true;


	first = false;
	count = 0;
	
	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			calendar[cy][cx] = 0;
			eventcalendar[cy][cx] = 0;
		}
	}		

	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			calendar[cy][cx] = count;
			if (cy == 0 && cx == wd) {
				count = 1;
				calendar[cy][cx] = count;
				first = true;
			}
			if (first) {
				count++;
				if (count == md) first = false;
			}
			else count = 0;
		}
	}
	
	for (cy = 0; cy < 6; cy++) {
		for (cx = 0; cx < 7; cx++) {
			for (count = 0; count < monthevents.size(); count++) {
				if (monthevents[count].day == calendar[cy][cx]) {
					eventcalendar[cy][cx] = 1;
				}
			}
		}
	}
}

int weekDay(int day,int mon,int yr){
  // Returns the day of the week for the given date, assumed valid and
  // in the Gregorian calendar.  The returned value is: 0 for Sunday,
  // 1 for Monday, ..., 6 for Saturday; or, if the preprocessor symbol
  // MONDAY_IS_0 is defined: 0 for Monday, 1 for Tuesday, ..., 6 for
  // Sunday.

  int result;

  if (mon < 3) {
    mon += 12;
    --yr;
  }

  result = day + (13 * mon - 27)/5 + yr + yr/4 - yr/100 + yr/400;

  return (result % 7);
}


string getMonth(int mon) {
	if (mon == 1) return "January";
	else if (mon == 2) return "Febuary";
	else if (mon == 3) return "March";
	else if (mon == 4) return "April";
	else if (mon == 5) return "May";
	else if (mon == 6) return "June";
	else if (mon == 7) return "July";
	else if (mon == 8) return "August";
	else if (mon == 9) return "September";
	else if (mon == 10) return "October";
	else if (mon == 11) return "November";
	else if (mon == 12) return "December";
}

string getDay(int d) {
	if (d == 0) return "Sunday";
	else if (d == 1) return "Monday";
	else if (d == 2) return "Tuesday";
	else if (d == 3) return "Wednesday";
	else if (d == 4) return "Thursday";
	else if (d == 5) return "Friday";
	else if (d == 6) return "Saturday";
}	

int getNumDays(int mon,int yr) {
	if (mon == 1) return 31;
	else if (mon == 2) {
			if (yr % 4 == 0) return 29;
			else return 28;
		}
	else if (mon == 3) return 31;
	else if (mon == 4) return 30;
	else if (mon == 5) return 31;
	else if (mon == 6) return 30;
	else if (mon == 7) return 31;
	else if (mon == 8) return 31;
	else if (mon == 9) return 30;
	else if (mon == 10) return 31;
	else if (mon == 11) return 30;
	else if (mon == 12) return 31;
}

