#include "clock.h"
#include "subprogram.h"

string timezones[] = {	
						"(GMT -12:00) International Date Line West",
						"(GMT -11:00) Midway Island, Samoa",
						"(GMT -10:00) Hawaii",
						"(GMT -09:00) Alaska",
						"(GMT -08:00) Pacific Time (US & Canada); Tijuana",
						"(GMT -07:00) Arizona",
						"(GMT -07:00) Chihuahua, La Paz, Mazatlan",
						"(GMT -07:00) Mountain Time (US & Canada)",
						"(GMT -06:00) Central America",
						"(GMT -06:00) Central Time (US & Canada)",
						"(GMT -06:00) Guadalajara, Mexico City, Monterrey",
						"(GMT -06:00) Saskatchewan",
						"(GMT -05:00) Bogota, Lima, Quito",
						"(GMT -05:00) Eastern Time (US & Canada)",
						"(GMT -05:00) Indiana (East)",
						"(GMT -04:00) Atlantic Time (Canada)",
						"(GMT -04:00) Caracas, La Paz",
						"(GMT -04:00) Santiago",
						"(GMT -03:30) Newfoundland",
						"(GMT -03:00) Brasilia",
						"(GMT -03:00) Buenos Aires, Georgetown",
						"(GMT -03:00) Greenland",
						"(GMT -02:00) Mid-Atlantic",
						"(GMT -01:00) Azores",
						"(GMT -01:00) Cape Verde Is.",
						"(GMT  00:00) Casablanca, Monrovia",
						"(GMT  00:00) Greenwich Mean Time : Dublin, Lisbon, London",
						"(GMT +01:00) Amsterdam, Berlin, Rome, Stockholm, Vienna",
						"(GMT +01:00) Belgrade, Bratislava, Budapest, Prague",
						"(GMT +01:00) Brussels, Copenhagen, Madrid, Paris",
						"(GMT +01:00) Sarajevo, Skopje, Warsaw, Zagreb",
						"(GMT +01:00) West Central Africa",
						"(GMT +02:00) Bucharest",
						"(GMT +02:00) Cairo",
						"(GMT +02:00) Harare, Pretoria",
						"(GMT +02:00) Helsinki, Kyiv, Riga, Sofia, Vilnius",
						"(GMT +02:00) Jerusalem",
						"(GMT +03:00) Baghdad",
						"(GMT +03:00) Kuwait, Riyadh",
						"(GMT +03:00) Moscow, St. Petersburg, Volgograd",
						"(GMT +03:00) Nairobi",
						"(GMT +03:30) Tehran",
						"(GMT +04:00) Abu Dhabi, Muscat",
						"(GMT +04:00) Baku, Tbilisi, Yerevan",
						"(GMT +04:30) Kabul",
						"(GMT +05:00) Ekaterinburg",
						"(GMT +05:00) Islamabad, Karachi, Tashkent",
						"(GMT +05:30) Chennai, Kokata, Mumbai, New Delhi",
						"(GMT +05:45) Kathmandu",
						"(GMT +06:00) Almaty, Novosibirsk",
						"(GMT +06:00) Astana, Dhaka",
						"(GMT +06:00) Sri Jayawardenepura",
						"(GMT +06:30) Rangoon",
						"(GMT +07:00) Bangkok, Hanoi, Jakarta",
						"(GMT +07:00) Krasnoyarsk",
						"(GMT +08:00) Beijing, Chongqing, Hong Kong, Urumqi",
						"(GMT +08:00) Irkutsk, Ulaan Bataar",
						"(GMT +08:00) Kuala Lumpur, Singapore",
						"(GMT +08:00) Perth",
						"(GMT +08:00) Taipei",
						"(GMT +09:00) Osaka, Sapporo, Tokyo",
						"(GMT +09:00) Seoul",
						"(GMT +09:00) Yakutsk",
						"(GMT +10:00) Brisbane",
						"(GMT +10:00) Canberra, Melbourne, Sydney",
						"(GMT +10:00) Guam, Port Moresby",
						"(GMT +10:00) Hobart",
						"(GMT +10:00) Vladivostok",
						"(GMT +11:00) Magadan, Solomon Is., New Caledonia",
						"(GMT +12:00) Auckland, Wellington",
						"(GMT +12:00) Fiji, Kamchatka, Marshall Is.",
						"(GMT +13:00) Nuku'alofa" };
						
extern vector <Dir> dir;
extern vector <string> dirimage;
extern SDL_Surface *img_text, *img_background, *img_arrow, *img_arrows, *img_dirbuttons, *img_editbuttons, *img_check, *img_doc, *img_dot, *img_folder, *img_music, *img_pic, *img_space, *screen, *im_screen;
extern SDL_Surface *img_rckeys, *img_lckeys, *img_lcskeys, *img_rcskeys, *img_lkeys, *img_rkeys, *img_lskeys, *img_rskeys;
extern SDL_Surface *img_textbackground, *tmp, *img_view, *img_test, *img_menubar;
extern TTF_Font *font, *drawfont, *drawfont10, *drawfont12, *drawfont14, *drawfont16, *drawfont20, *drawfont50, *systemfont;
extern SDL_Color sdlwhite;
extern SDL_Color sdlblack;
extern SDL_Color sdlgrey;
extern SDL_Color sdldarkgrey;
extern SDL_Color sdlred;
extern SDL_Color sdlgreen;
extern SDL_Color sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, white, black, grey, lightgrey, darkgrey, red, green, blue, cursorcol;
extern string readfile, currentdir;
extern bool bmUpdate, isplaying, ispaused, padrelease, bAlarm,transition,bview;
extern int nLine,nCol,wait;
extern int menu, menumode ,dirselect, mode, nKeyset, nFontsize, menucursor;
extern SceCtrlData pad;
extern int blx,bly,blh;
extern codecStubs *decoder;

int clockselect=0, clockscroll=0, clockcursor=0, clockmaxlines = 10;
int timezonesize = 72;
static int entry = 1;
int alarmhour = 12, alarmmin = 0, tmpalarmhour = 12, tmpalarmmin = 0;
int swhour = 0, swmin = 0, swsec = 0, swmsec = 0;
int thour = 0, tmin = 10, tsec = 0, tmsec = 0;
string alarmch = "PM", tmpalarmch = "PM";
bool alarmset = false, bStopwatch, bTimer, bwcToggle = true;


void checkClock(void)
{
	if (alarmset)
	{
		time_t tTime;
		struct tm * tmTime;
		string ch = "AM";
		
		time(&tTime);
		tmTime = localtime(&tTime);
		
		if (tmTime->tm_hour >= 12) 
		{
			if (tmTime->tm_hour > 12) tmTime->tm_hour-=12;
			ch = "PM";
		}
		if (tmTime->tm_hour == 0) tmTime->tm_hour = 12;
		//sprintf(sizestring,"%2i:%02i%s", tmTime->tm_hour, tmTime->tm_min, ch.c_str());		
		
		if (tmTime->tm_hour == alarmhour && tmTime->tm_min == alarmmin 
			&& tmTime->tm_sec == 0 && ch == alarmch)
		{
			if (isplaying) 
			{
				decoder->stop();
				decoder->end();
			}
			if (bview) {
				SDL_FreeSurface(img_view);
				bview = false;
			}			
			load_play("alarm.mp3");
			isplaying = true;
			bAlarm = true;
			menumode = CLOCK;
		}
	}
}

void getClockInput(void) 
{
	if (pad.Buttons & PSP_CTRL_CROSS && !transition)
	{
		tmpalarmhour = alarmhour;
		tmpalarmmin = alarmmin;
		tmpalarmch = alarmch;
		menumode = SETCLOCKMENU;
		transition = true;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_TRIANGLE && padrelease)
	{
		if (bAlarm)
		{
			decoder->stop();
			decoder->end();
			isplaying = false;
			bAlarm = false;
		}
		
		alarmset = !alarmset;
		bmUpdate = true;
		padrelease = false;
		wait = 120;
	}
	
	if (pad.Buttons & PSP_CTRL_CIRCLE)
	{
		menumode = WORLDCLOCK;
		bmUpdate = true;
	}
}

void displayClock(void) 
{
	time_t tTime;
	struct tm * tmTime;
	char sizestring[8];
	string sTime, ch = "AM";
	
	time(&tTime);
	tmTime = localtime(&tTime);
	
	if (tmTime->tm_hour >= 12) 
	{
		if (tmTime->tm_hour > 12) tmTime->tm_hour-=12;
		ch = "PM";
	}	
	if (tmTime->tm_hour == 0) tmTime->tm_hour = 12;
	sTime = asctime(tmTime);
	sTime.resize(sTime.size()-1);
	//blit(im_screen,0,0,img_background);
	drawMenuFrame(im_screen);
	drawFillRect(im_screen,26,27,428,133,black);
	drawText(font,im_screen,240-sTime.size()*7/2,16,sTime,sdlblack);
	

	sprintf(sizestring,"%2i:%02i%s", tmTime->tm_hour, tmTime->tm_min, ch.c_str());
	sTime = sizestring;
	drawText(drawfont50,im_screen,32,50,sTime,sdlred);
	
	if (alarmset)
	{
		drawText(font,im_screen, 32, 145, "Alarm On", sdlred);
	}
	
	drawText(systemfont,im_screen,30,161,"Set Alarm:         Toggle Alarm:            World Clock:",sdlblack);
	drawText(systemfont,im_screen,30,161,"           Cross                 Triangle                Circle",sdlblue);
}

void displaySetClock(void) 
{
	char sizestring[8];
	string sTime, ch = "AM";
	
	//blit(im_screen,0,0,img_background);
	drawMenuFrame(im_screen);
	drawFillRect(im_screen,26,27,428,133,black);
	sTime = "Set Alarm Clock";
	drawText(font,im_screen,240-sTime.size()*7/2,16,sTime,sdlblack);
	

	sprintf(sizestring,"%2i:%02i%s", tmpalarmhour, tmpalarmmin, tmpalarmch.c_str());	
	drawText(drawfont50,im_screen,32,50,sizestring,sdlred);
	if (entry == 1)
	{
		sprintf(sizestring,"%2i", tmpalarmhour);
		drawText(drawfont50,im_screen,34,52,sizestring,sdlwhite);
	}
	if (entry == 2)
	{
		sprintf(sizestring,"   %02i", tmpalarmmin);
		drawText(drawfont50,im_screen,34,52,sizestring,sdlwhite);
	}
	if (entry == 3)
	{
		sprintf(sizestring,"     %s", tmpalarmch.c_str());
		drawText(drawfont50,im_screen,34,52,sizestring,sdlwhite);
	}	
}

void getSetClockInput(void) 
{
	if (pad.Buttons & PSP_CTRL_LEFT)
	{
		if (entry == 1) entry = 3;
		else entry--;
		bmUpdate = true;
		wait = 120;
	}
	
	if (pad.Buttons & PSP_CTRL_RIGHT)
	{
		if (entry == 3) entry = 1;
		else entry++;
		bmUpdate = true;
		wait = 120;		
	}
	
	if (pad.Buttons & PSP_CTRL_UP)
	{
		if (entry == 1)
		{
			if (tmpalarmhour == 12) tmpalarmhour = 1;
			else tmpalarmhour++;
		}
		if (entry == 2)
		{
			if (tmpalarmmin == 59) tmpalarmmin = 0;
			else tmpalarmmin++;
		}
		if (entry == 3)
		{
			if (tmpalarmch == "PM") tmpalarmch = "AM";
			else tmpalarmch = "PM";
		}
		bmUpdate = true;
		wait = 120;			
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN)
	{
		if (entry == 1)
		{
			if (tmpalarmhour == 1) tmpalarmhour = 12;
			else tmpalarmhour--;
		}
	
		if (entry == 2)
		{
			if (tmpalarmmin == 0) tmpalarmmin = 59;
			else tmpalarmmin--;
		}
		
		if (entry == 3)
		{
			if (tmpalarmch == "PM") tmpalarmch = "AM";
			else tmpalarmch = "PM";
		}
		bmUpdate = true;
		wait = 120;		
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS && !transition)
	{
		alarmhour = tmpalarmhour;
		alarmmin = tmpalarmmin;
		alarmch = tmpalarmch;
		bmUpdate = true;
		transition = true;
		menumode = CLOCK;
	}
		
}

void getWorldClockInput(void) 
{
	if (pad.Buttons & PSP_CTRL_UP) {
		if ((clockselect + clockscroll == 0) && clockselect > 0) clockscroll++;
		clockselect--;
		if (clockselect < 0) clockselect = 0;
		clockcursor--;
		if (clockcursor < 0) clockcursor = 0;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if ((clockselect + clockscroll == clockmaxlines-1) && clockselect < timezonesize-1) clockscroll--;
		clockselect++;
		if (clockselect == timezonesize) clockselect = timezonesize-1;
		clockcursor++;
		if (clockcursor == clockmaxlines) clockcursor = clockmaxlines-1;
		
		if (clockcursor == timezonesize) clockcursor = timezonesize-1;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS && padrelease)
	{
		bwcToggle = !bwcToggle;
		padrelease = false;
		bmUpdate = true;
	}
}					
						
void displayWorldClock(void) {
	int count = 0;
	time_t rawtime;
	tm * ptm, * ptmp;
	char sizestring[20];
	string ch;
	
	time ( &rawtime );
	
	ptm = gmtime ( &rawtime );
	
	drawMenuFrame(im_screen);
	
	drawText(font,im_screen,202,17,"World Clock", sdlblack);	
	
	for (count = 0; count < timezonesize; count++) 
	{
		if (clockselect == count) 
		{
			drawFillRect(im_screen,34,35+clockcursor*nLine - 1, 410, nLine, grey);
		}
		if ((clockscroll*nLine + count*nLine) < 120 && (clockscroll*nLine + count*nLine) >= 0) 
		{
			int hour = atoi(timezones[count].substr(5,3).c_str());
			int minute = atoi(timezones[count].substr(9,2).c_str());
			
			if (ptm->tm_hour+hour <= 0)
			{
				ch = "PM";
				if (ptm->tm_hour+hour+12 == 12) ch = "AM";
				sprintf(sizestring,"%2d:%02d %s",ptm->tm_hour+hour+12,ptm->tm_min+minute,ch.c_str());
			}
			else if (ptm->tm_hour+hour > 12)
			{
				if (ptm->tm_hour+hour > 24)
				{
					ch = "AM";
					if (ptm->tm_hour+hour-24 == 12) ch = "PM";
					sprintf(sizestring,"%2d:%02d %s",ptm->tm_hour+hour-24,ptm->tm_min+minute,ch.c_str());
				}
				else 
				{
					ch = "PM";
					if (ptm->tm_hour+hour-12 == 12) ch = "AM";
					sprintf(sizestring,"%2d:%02d %s",ptm->tm_hour+hour-12,ptm->tm_min+minute,ch.c_str());
				}
			}
			else
			{			
				ch = "AM";
				if (ptm->tm_hour+hour == 12) ch = "PM";
				sprintf(sizestring,"%2d:%02d %s",ptm->tm_hour+hour,ptm->tm_min+minute,ch.c_str());
			}
			
			drawText(font,im_screen,35,35+clockscroll*nLine+count*nLine, timezones[count].substr(13), sdlblack);
			if (!bwcToggle) drawText(font,im_screen,374,35+clockscroll*nLine+count*nLine, timezones[count].substr(1,10), sdlblack);
			else drawText(font,im_screen,388,35+clockscroll*nLine+count*nLine, sizestring, sdlblack);
		}
	}
}

bool swStart(void)
{
	return bStopwatch;
}

bool tStart(void)
{
	return bTimer;
}

void updateStopwatch(void)
{
	swmsec+=100;
	if (swmsec == 1000)
	{
		swsec++;
		swmsec = 0;
	}
	if (swsec == 60)
	{
		swmin++;
		swsec = 0;
	}
	if (swmin == 60)
	{
		swhour++;
		swmin = 0;
	}
	if (swhour == 24)
	{
		swhour = 0;
	}
}
void getStopwatchInput(void)
{
	if (pad.Buttons & PSP_CTRL_CROSS && padrelease)
	{
		bStopwatch = !bStopwatch;
		padrelease = false;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_TRIANGLE)
	{
		swhour = 0;
		swmin = 0;
		swsec = 0;
		swmsec = 0;
		bmUpdate = true;
	}
}

void displayStopwatch(void) 
{
	char sizestring[20];
	
	drawMenuFrame(im_screen);
	drawFillRect(im_screen,26,27,428,133,black);
	string sTime = "Stopwatch";
	drawText(font,im_screen,240-sTime.size()*7/2,16,sTime,sdlblack);
	

	sprintf(sizestring,"%2i:%02i:%02i:%02i", swhour, swmin, swsec, swmsec/10);
	sTime = sizestring;
	drawText(drawfont20,im_screen,32,50,sTime,sdlred);
		
	drawText(systemfont,im_screen,30,161,"Start/Stop:        Reset:",sdlblack);
	drawText(systemfont,im_screen,30,161,"            Cross         Triangle",sdlblue);
}

void getTimerInput(void)
{
	if (pad.Buttons & PSP_CTRL_CROSS && padrelease && !transition)
	{
		bTimer = !bTimer;
		tmsec = 1000;
		padrelease = false;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_TRIANGLE)
	{
		if (isplaying) {
			decoder->stop();
			decoder->end();
			isplaying = false;
			ispaused = false;
			bAlarm = false;
		}
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_LEFT)
	{
		entry--;
		if (entry == 0) entry = 3;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_RIGHT)
	{
		entry++;
		if (entry == 4) entry = 1;
		bmUpdate = true;
	}	
	
	if (pad.Buttons & PSP_CTRL_UP)
	{
		if (entry == 1)
		{
			thour++;
			if (thour == 25) thour = 0;
		}
		if (entry == 2)
		{
			tmin++;
			if (tmin == 60) tmin = 0;
		}
		if (entry == 3)
		{
			tsec++;
			if (tsec == 60) tsec = 0;
		}
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN)
	{
		if (entry == 1)
		{
			thour--;
			if (thour == -1) thour = 24;
		}
		if (entry == 2)
		{
			tmin--;
			if (tmin == -1) tmin = 59;
		}
		if (entry == 3)
		{
			tsec--;
			if (tsec == -1) tsec = 59;
		}
		bmUpdate = true;
	}	
}

void updateTimer(void)
{
	tmsec-=100;
	if (tmsec == -100 && (thour > 0 || tmin > 0 || tsec > 0))
	{
		tsec--;
		tmsec = 900;
	}
	if (tsec == -1 && (thour > 0 || tmin > 0))
	{
		tmin--;
		tsec = 59;
	}
	if (tmin == -1 && thour > 0)
	{
		thour--;
		tmin = 59;
	}
	if (thour == 0 && tmin == 0 && tsec == 0 && tmsec == 0)
	{		
		if (isplaying) 
		{
			decoder->stop();
			decoder->end();
		}
		if (bview) {
			SDL_FreeSurface(img_view);
			bview = false;
		}			
		load_play("alarm.mp3");
		isplaying = true;
		bTimer = false;
		bAlarm = true;
		bmUpdate = true;
		menumode = TIMER;
	}
}

void displayTimer(void) 
{
	char sizestring[20];
	
	drawMenuFrame(im_screen);
	drawFillRect(im_screen,26,27,428,133,black);
	string sTime = "Timer";
	drawText(font,im_screen,240-sTime.size()*7/2,16,sTime,sdlblack);
	
	int tmmsec = tmsec/10;
	if (tmmsec == 100) tmmsec = 0;
	sprintf(sizestring,"%2i:%02i:%02i:%02i", thour, tmin, tsec, tmmsec);
	sTime = sizestring;
	drawText(drawfont20,im_screen,32,50,sTime,sdlred);
	if (entry == 1)
	{
		sprintf(sizestring,"%2i", thour);
		drawText(drawfont20,im_screen,34,52,sizestring,sdlwhite);
	}
	if (entry == 2)
	{
		sprintf(sizestring,"   %02i", tmin);
		drawText(drawfont20,im_screen,34,52,sizestring,sdlwhite);
	}
	if (entry == 3)
	{
		sprintf(sizestring,"      %02i", tsec);
		drawText(drawfont20,im_screen,34,52,sizestring,sdlwhite);
	}		
		

	if (bAlarm)
	{
		drawText(systemfont,im_screen,30,161,"Start/Stop:        Stop Alarm:",sdlblack);
		drawText(systemfont,im_screen,30,161,"            Cross              Triangle",sdlblue);	
	}
	else
	{
		drawText(systemfont,im_screen,30,161,"Start/Stop:       ",sdlblack);
		drawText(systemfont,im_screen,30,161,"            Cross",sdlblue);	
	}
}

void getClockMenuInput(void) {
	if (padrelease) {
		if (pad.Buttons & PSP_CTRL_RIGHT) {
			menu = 1;
			menucursor = 1;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_LEFT) {
			menu = 4;
			menucursor = 1;
			wait = 100;
			padrelease = false;
			bmUpdate = true;
		}
	}

	
	if (pad.Buttons & PSP_CTRL_UP) {
		if (menucursor == 1) menucursor = 2;
		else menucursor--;
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if (menucursor == 2) menucursor = 1;
		else menucursor++;
		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS)
	{
		if (menucursor == 1)
		{
			menumode = STOPWATCH;
			padrelease = false;
			wait = 100;
			bmUpdate = true;
		}
		if (menucursor == 2)
		{
			menumode = TIMER;
			entry = 1;
			padrelease = false;
			wait = 100;
			bmUpdate = true;
		}
		menu = 0;
	}
}

void displayClockMenu(SDL_Surface *surface) {
	int menupos;
	
	blit(surface, 0,0, img_menubar);
	if (menu == 1) {
		drawFillRect(surface,8,0,32,10,darkgrey);
	}
	if (menu == 3) {
		drawFillRect(surface,58,0,32,10,darkgrey);
	}
	if (menu == 4) {
		drawFillRect(surface,108,0,39,10,darkgrey);
	}	
	if (menu == 8) {
		drawFillRect(surface,158,0,39,10,darkgrey);
	}
	drawText(font,surface,11,0, "File", sdlblack);
	drawText(font,surface,61,0, "View", sdlblack);
	if (isplaying) drawText(font,surface,111,0, "Music", sdlblack);
	else drawText(font,surface,111,0, "Music", sdldarkgrey);	
	drawText(font,surface,161,0, "Clock", sdlblack);

	if (menu == 8) {
		menupos = 160;
		
		drawText(font,surface,menupos,0, "Clock", sdlwhite);

		drawDropmenu(surface, menupos, 11, 9, 2);
		
		drawFillRect(surface,menupos+6,menucursor*nLine+4, 4*nCol+nCol*9-8, nLine, blue);
		
		if (menucursor == 1) {
			drawTextShadowed(font,surface,menupos+20,nLine+4, "Stopwatch", sdlwhite);
		}
		else {
			drawText(font,surface,menupos+20,nLine+4, "Stopwatch", sdlblack);
		}
		if (menucursor == 2) {
			drawTextShadowed(font,surface,menupos+20,2*nLine+4, "Timer", sdlwhite);
		}
		else {
			drawText(font,surface,menupos+20,2*nLine+4, "Timer", sdlblack);
		}

	}	

}
