#include "subprogram.h"
#include "frontend.h"

extern TTF_Font *font, *systemfont;
extern SDL_Color sdlwhite, sdlblack, sdlgrey, sdldarkgrey, sdlblue;
extern SDL_Color forecol, fgcol, bgcol;
extern Uint32 backcol, grey, lightgrey, darkgrey, blue;
 

extern int wait, menu, mode, menumode, menucursor, lastmode, nFontsize, colcursor;
extern int directorymode, dirscroll, dircursor, dirselect, nLine, nCol;
extern bool bmUpdate, transition, padrelease, usb, bEndprogram, isplaying;
extern SceCtrlData pad;
extern string audiodir, filedir, photodir, theme;
extern SDL_Surface *im_screen, *img_background, *img_menubar, *img_check;
extern SDL_Surface *img_addressbookicon, *img_fileicon, *img_calendaricon, *img_calculatoricon, *img_notepadicon, *img_musicicon, *img_photoicon, *img_clockicon, *img_settingsicon;

int ax = 1, ay = 1;
int thscroll, thselect, thcursor, thmaxlines = 10;
vector <string> themedir;

void getFrontendInput(void)
{
	int month, year;
	time_t tTime;
	struct tm * tmTime;
	
	if (pad.Buttons & PSP_CTRL_UP || pad.Ly == 0) {
		if (ay == 1) ay = 3;
		else ay--;
		wait = 180;
		bmUpdate = true;
	}
	if (pad.Buttons & PSP_CTRL_DOWN || pad.Ly == 255) {
		if (ay == 3) ay = 1;
		else ay++;
		wait = 180;					
		bmUpdate = true;					
	}
	if (pad.Buttons & PSP_CTRL_LEFT || pad.Lx == 0) {
		if (ax == 1) ax = 3;
		else ax--;
		wait = 180;
		bmUpdate = true;						
	}
	if (pad.Buttons & PSP_CTRL_RIGHT || pad.Lx == 255) {
		if (ax == 3) ax = 1;
		else ax++;
		wait = 180;
		bmUpdate = true;						
	}		
	if (pad.Buttons & PSP_CTRL_CROSS && !transition) {
		if (ax == 1 && ay == 1) 
		{
			mode = 1;
		}
		if (ax == 2 && ay == 1) {
			loadBook();
			mode = 5;
			menumode = 0;
			initAddressBook();
		}
		if (ax == 3 && ay == 1) {
			mode = 7;
			menumode = 0;
			time (&tTime);
			tmTime = localtime(&tTime);
			if (tmTime->tm_hour > 12) tmTime->tm_hour-=12;
			year = tmTime->tm_year+1900;
			month = tmTime->tm_mon+1;
			initCalendar(tmTime->tm_mday, month, year);
			setCalendar(month,year);
		}
		if (ax == 1 && ay == 2) {
			mode = 6;
			menumode = 0;
			initCalculator();					
		}
		if (ax == 2 && ay == 2) {
			directorymode = 2;
			listDirectory(audiodir);
			menumode = 5;
			dircursor = 0;
			dirselect = 0;
			dirscroll = 0;			
		}
		if (ax == 3 && ay == 2) {
			directorymode = 3;
			listDirectory(photodir);
			menumode = 5;
			dircursor = 0;
			dirselect = 0;
			dirscroll = 0;			
		}
		if (ax == 1 && ay == 3) {						
			directorymode = 1;
			listDirectory(filedir);
			menumode = 5;
			dircursor = 0;
			dirselect = 0;
			dirscroll = 0;					
		}
		if (ax == 2 && ay == 3) {
			menumode = CLOCK;
		}
		if (ax == 3 && ay == 3) {
		}
		padrelease = false;
		transition = true;
		bmUpdate = true;
		menu = 0;
						
	}
}

void displayFrontend(void)
{
	blit(im_screen, 0,0, img_background);
	blit(im_screen, 0,0, img_menubar);
	drawTextShadowed(font,im_screen, 215, 0, "PSP-PDA", sdlwhite);
	
	if (ax == 1 && ay == 1) {
		drawFillRect(im_screen, 80, 40,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 72, 80, "Notepad", sdlwhite);
	}
	else drawText(font, im_screen, 72, 75, "Notepad", sdlblack);
	if (ax == 2 && ay == 1) {
		drawFillRect(im_screen, 224, 40,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 198, 75, "Address Book", sdlwhite);
	}
	else drawText(font, im_screen, 198, 75, "Address Book", sdlblack);
	if (ax == 3 && ay == 1) {
		drawFillRect(im_screen, 368, 40,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 356, 75, "Calendar", sdlwhite);
	}
	else drawText(font, im_screen, 356, 75, "Calendar", sdlblack);
	if (ax == 1 && ay == 2) {
		drawFillRect(im_screen, 80, 130,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 61, 165, "Calculator", sdlwhite);
	}
	else drawText(font, im_screen, 61, 165, "Calculator", sdlblack);
	if (ax == 2 && ay == 2) {
		drawFillRect(im_screen, 224, 130,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 222, 165, "Music", sdlwhite);
	}
	else drawText(font, im_screen, 222, 165, "Music", sdlblack);
	if (ax == 3 && ay == 2) {
		drawFillRect(im_screen, 368, 130,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 366, 165, "Images", sdlwhite);
	}
	else drawText(font, im_screen, 366, 165, "Images", sdlblack);
	if (ax == 1 && ay == 3) {
		drawFillRect(im_screen, 80, 220,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 54, 255, "File Manager", sdlwhite);
	}
	else drawText(font, im_screen, 54, 255, "File Manager", sdlblack);
	if (ax == 2 && ay == 3) {
		drawFillRect(im_screen, 224, 220,32,32, lightgrey);
		drawTextShadowed(font, im_screen, 222, 255, "Clock", sdlwhite);
	}
	else drawText(font, im_screen, 222, 255, "Clock", sdlblack);
	
	blit(im_screen, 80, 40, img_notepadicon);
	blit(im_screen, 224, 40, img_addressbookicon);
	blit(im_screen, 368, 40, img_calendaricon);
	blit(im_screen, 80, 130, img_calculatoricon);
	blit(im_screen, 224, 130, img_musicicon);
	blit(im_screen, 368, 130, img_photoicon);
	blit(im_screen, 80, 220, img_fileicon);
	blit(im_screen, 224, 220, img_clockicon);
}

void getFrontendDropMenuInput(void)
{
	time_t tTime;
	struct tm * tmTime;
	int retval;
	u32 state;
	int month, year;
	
	if (menu == 1) {
		if (pad.Buttons & PSP_CTRL_UP) {
			menucursor--;
			if (menucursor < 1) {
				menucursor = 10;
			}
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			menucursor++;
			if (menucursor > 10) {
				menucursor = 1;
			}
			wait = 100;
			bmUpdate = true;
		}
		
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_RIGHT) {
				if (menumode >= CLOCK && menumode <= TIMER) menu = 3;
				else if (mode > 0 && mode < 4) {
					mode = 2;
					menu = 2;
				}
				else menu = 3;
				menucursor = 1;
				wait = 100;
				padrelease = false;
				bmUpdate = true;
			}
		
			if (pad.Buttons & PSP_CTRL_LEFT) {
				if (menumode >= CLOCK && menumode <= TIMER) menu = 8;
				else if (mode == IMAGE) menu = 5;
				else if (mode == CALENDAR) menu = 7;
				else if (mode == CALCULATOR) 
				{
					menu = 6;
					initCalculatorMenu();
				}
				else menu = 4;
				menucursor = 1;
				wait = 100;
				padrelease = false;
				bmUpdate = true;
			}
		}
		
		if (pad.Buttons & PSP_CTRL_CROSS) {
	
			if (menucursor == 1) {
				initNotepad();
				update();
				mode = 1;
			}
			if (menucursor == 2) {
				menumode = 5;
				directorymode = 1;
				listDirectory(filedir);
				dircursor = 0;
				dirselect = 0;
				dirscroll = 0;
			}
			if (menucursor == 3) {
				if (mode >= KEYBOARD && mode < FULLSCREEN)
				{
					menumode = 6;
					saveText();
				}
				if (mode == ADDRESSBOOK)
				{
					saveBook();
				}
				if (mode == CALENDAR)
				{
					saveCalendar();
				}
			}
			if (menucursor == 4) {
#ifdef KERNEL			
				state = sceUsbGetState();
				usb = !usb;
				
				if (state & PSP_USB_ACTIVATED) retval = sceUsbDeactivate(0);
				else retval = sceUsbActivate(0x1c8);
#endif /*KERNEL*/				
			}
			if (menucursor == 5) {
				loadBook();
				mode = 5;
				menumode = 0;
				initAddressBook();
			}
			if (menucursor == 6) {
				mode = 6;
				menumode = 0;
				initCalculator();
			}
			if (menucursor == 7) {			
				mode = 7;
				menumode = 0;
				time ( &tTime);
				tmTime = localtime(&tTime);
				if (tmTime->tm_hour > 12) tmTime->tm_hour-=12;
				year = tmTime->tm_year+1900;
				month = tmTime->tm_mon+1;
				initCalendar(tmTime->tm_mday,month,year);
				setCalendar(month,year);
			}
			if (menucursor == 8) {
				menumode = CLOCK;
			}
			if (menucursor == 9) {
				menumode = 0;
				mode = 0;
			}
			if (menucursor == 10) {
				if (state & PSP_USB_ACTIVATED) retval = sceUsbDeactivate(0);
				bEndprogram = true;
			}
			menu = 0;
			wait = 100;
			bmUpdate = true;
			padrelease = false;
			transition = true;
		}
	}

	if (menu == 3) {
		if (padrelease) {
			if (pad.Buttons & PSP_CTRL_RIGHT) {
				menu = 4;
				menucursor = 1;
				wait = 100;
				padrelease = false;
				bmUpdate = true;
			}
			
			if (pad.Buttons & PSP_CTRL_LEFT) {
				lastmode = mode;
				if (menumode >= CLOCK && menumode <= TIMER) menu = 1;
				else if (mode > 0 && mode < 4) {
					mode = 2;
					menu = 2;
				}
				else menu = 1;
				menucursor = 1;
				wait = 100;
				padrelease = false;
				bmUpdate = true;
			}
		}
		
		if (pad.Buttons & PSP_CTRL_UP) {
			if (menucursor == 1) menucursor = 11;
			else menucursor--;
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_DOWN) {
			if (menucursor == 11) menucursor = 1;
			else menucursor++;
			wait = 100;
			bmUpdate = true;
		}
		
		if (pad.Buttons & PSP_CTRL_CROSS) {
			if (menucursor == 1 && mode >= KEYBOARD && mode <= FULLSCREEN) {
				mode = 3;
				setWordwrap();
				update();
			}
			if (menucursor == 2) {
				menumode = 18;
				transition = true;
				padrelease = false;
				colcursor = 0;
				update();
			}
			if (menucursor == 3) {
				setWordwrap1();
				mode = lastmode;
				
				/*
				if (mode == 3) {
					scrollx = 0;
					scrolly = 0;
				}
				*/
				
				wait = 200;
			}
			if (menucursor == 4) {
				setWordwrap2();
				mode = lastmode;
				
				/*
				if (mode == 3) {
					scrollx = 0;
					scrolly = 0;
				}
				*/
				
				wait = 200;
			}
			if (menucursor == 5) {
				if (nFontsize != 10) {
					nFontsize -= 2;
					setBounds(nFontsize);
					setWordwrap();
					saveSettings();
				}
				update();			
			}
			if (menucursor == 6) {
				if (nFontsize != 16) {
					nFontsize += 2;
					setBounds(nFontsize);
					setWordwrap();
					saveSettings();
				}
				update();			
			}
			if (menucursor == 7) {
				colcursor = 1;
				SDL_GetRGB(backcol, im_screen->format, &(bgcol.r), &(bgcol.g), &(bgcol.b));
				lastmode = mode;
				menumode = 11;
				padrelease = false;
			}
			if (menucursor == 8) {
				colcursor = 1;
				fgcol = forecol;
				lastmode = mode;
				menumode = 12;
				padrelease = false;
			}
			if (menucursor == 9)
			{
				menumode = THEME;
				thselect = 0;
				thcursor = 0;
				thscroll = 0;
				listThemeDirectory(themedir);
			}
			if (menucursor == 10 && mode == FULLSCREEN) {
				toggleBookmark();
			}
			
			if (menucursor == 11 && mode == FULLSCREEN) {
				gotoBookmark();
			}				
			menu = 0;
			bmUpdate = true;
			transition = true;
		}
	}	
}

void displayFrontendDropMenu(void)
{
	int menupos;
	
	if (menu > 0 && (mode == FRONTEND || mode == ADDRESSBOOK) && (menumode < CLOCK || menumode > TIMER)) {

		blit(im_screen, 0,0, img_menubar);
		if (menu == 1) {
			drawFillRect(im_screen,8,0,32,10,darkgrey);
		}
		if (menu == 3) {
			drawFillRect(im_screen,58,0,32,10,darkgrey);
		}
		if (menu == 4) {
			drawFillRect(im_screen,108,0,39,10,darkgrey);
		}
		drawText(font,im_screen,11,0, "File", sdlblack);
		drawText(font,im_screen,61,0, "View", sdlblack);
		if (isplaying) drawText(font,im_screen,111,0, "Music", sdlblack);
		else drawText(font,im_screen,111,0, "Music", sdldarkgrey);
	}		
	
	if (menu == 1) {
		menupos = 10;
		
		drawText(font,im_screen,menupos,0, "File", sdlwhite);

		drawDropmenu(im_screen, menupos, 11, 12, 10);
		
		drawFillRect(im_screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*12-8, nLine, blue);

		if (menucursor == 1) drawTextShadowed(font,im_screen,menupos+20,nLine+4, "New Text", sdlwhite);
		else drawText(font,im_screen,menupos+20,nLine+4, "New Text", sdlblack);
		
		if (menucursor == 2) drawTextShadowed(font,im_screen,menupos+20,2*nLine+4, "Open", sdlwhite);
		else drawText(font,im_screen,menupos+20,2*nLine+4, "Open", sdlblack);
		
		if (menucursor == 3) drawTextShadowed(font,im_screen,menupos+20,3*nLine+4, "Save", sdlwhite);
		else drawText(font,im_screen,menupos+20,3*nLine+4, "Save", sdlblack);
		
		if (menucursor == 4) {
			drawTextShadowed(font,im_screen,menupos+20,4*nLine+4, "USB", sdlwhite);
			if (usb) blit(im_screen,menupos+4,4*nLine+6,img_check);
		}
		else {
			drawText(font,im_screen,menupos+20,4*nLine+4, "USB", sdlblack);
			if (usb) blit(im_screen,menupos+4,4*nLine+6,img_check);
		}

		if (menucursor == 5) drawTextShadowed(font,im_screen,menupos+20,5*nLine+4, "Address Book", sdlwhite);
		else drawText(font,im_screen,menupos+20,5*nLine+4, "Address Book", sdlblack);
		if (menucursor == 6) drawTextShadowed(font,im_screen,menupos+20,6*nLine+4, "Calculator", sdlwhite);
		else drawText(font,im_screen,menupos+20,6*nLine+4, "Calculator", sdlblack);
		if (menucursor == 7) drawTextShadowed(font,im_screen,menupos+20,7*nLine+4, "Calendar", sdlwhite);
		else drawText(font,im_screen,menupos+20,7*nLine+4, "Calendar", sdlblack);
		if (menucursor == 8) drawTextShadowed(font,im_screen,menupos+20,8*nLine+4, "Clock", sdlwhite);
		else drawText(font,im_screen,menupos+20,8*nLine+4, "Clock", sdlblack);		
		if (menucursor == 9) drawTextShadowed(font,im_screen,menupos+20,9*nLine+4, "Applications", sdlwhite);
		else drawText(font,im_screen,menupos+20,9*nLine+4, "Applications", sdlblack);
		if (menucursor == 10) drawTextShadowed(font,im_screen,menupos+20,10*nLine+4, "Exit", sdlwhite);
		else drawText(font,im_screen,menupos+20,10*nLine+4, "Exit", sdlblack);		
	}
	
			
	if (menu == 3) {
		if (mode > 0 && mode < 4 && menumode != CLOCK) menupos = 110;
		if (mode >= 4 || mode == 0 || menumode == CLOCK) menupos = 60;
		drawText(font,im_screen,menupos,0, "View", sdlwhite);

		drawDropmenu(im_screen, menupos, 11, 17, 11);
		
		drawFillRect(im_screen,menupos+6,menucursor*nLine+4, 4*nCol+nCol*17-8, nLine, blue);		
		
		if (menucursor == 1) drawTextShadowed(font,im_screen,menupos+20, nLine+4, "Full Screen", sdlwhite);
		else drawText(font,im_screen,menupos+20, nLine+4, "Full Screen", sdlblack);
		
		if (menucursor == 2) {
			drawTextShadowed(font,im_screen,menupos+20,2*nLine+4, "Keyboard Settings", sdlwhite);
		}
		else {
			drawText(font,im_screen,menupos+20,2*nLine+4, "Keyboard Settings", sdlblack);
		}
		if (menucursor == 3) {
			drawTextShadowed(font,im_screen,menupos+20,3*nLine+4, "Word Wrap 1", sdlwhite);
			if (getWordwrap1()) blit(im_screen,menupos+4,3*nLine+6,img_check);
		}
		else {
			drawText(font,im_screen,menupos+20,3*nLine+4, "Word Wrap 1", sdlblack);
			if (getWordwrap1()) blit(im_screen,menupos+4,3*nLine+6,img_check);
		}
		if (menucursor == 4) {
			drawTextShadowed(font,im_screen,menupos+20,4*nLine+4, "Word Wrap 2", sdlwhite);
			if (getWordwrap2()) blit(im_screen,menupos+4,4*nLine+6,img_check);
		}
		else {
			drawText(font,im_screen,menupos+20,4*nLine+4, "Word Wrap 2", sdlblack);
			if (getWordwrap2()) blit(im_screen,menupos+4,4*nLine+6,img_check);
		}
		if (menucursor == 5) {
			if (nFontsize > 10) drawTextShadowed(font,im_screen,menupos+20,5*nLine+4, "Font Size -", sdlwhite);
			else drawText(font,im_screen,menupos+20,5*nLine+4, "Font Size -", sdlgrey);
		}
		else {
			if (nFontsize > 10) drawText(font,im_screen,menupos+20,5*nLine+4, "Font Size -", sdlblack);
			else drawText(font,im_screen,menupos+20,5*nLine+4, "Font Size -", sdlgrey);
		}
		if (menucursor == 6) {
			if (nFontsize < 16) drawTextShadowed(font,im_screen,menupos+20,6*nLine+4, "Font Size +", sdlwhite);
			else drawText(font,im_screen,menupos+20,6*nLine+4, "Font Size +", sdlgrey);
		}
		else {
			if (nFontsize < 16) drawText(font,im_screen,menupos+20,6*nLine+4, "Font Size +", sdlblack);
			else drawText(font,im_screen,menupos+20,6*nLine+4, "Font Size +", sdlgrey);
		}
		if (menucursor == 7) drawTextShadowed(font,im_screen, menupos+20,7*nLine+4, "Background Color", sdlwhite);
		else drawText(font,im_screen,menupos+20,7*nLine+4,"Background Color", sdlblack);
		if (menucursor == 8) drawTextShadowed(font,im_screen, menupos+20,8*nLine+4, "Text Color", sdlwhite);
		else drawText(font,im_screen,menupos+20,8*nLine+4,"Text Color", sdlblack);
		if (menucursor == 9) drawTextShadowed(font,im_screen, menupos+20,9*nLine+4, "Theme", sdlwhite);
		else drawText(font,im_screen,menupos+20,9*nLine+4,"Theme", sdlblack);		
		if (menucursor == 10) drawTextShadowed(font,im_screen, menupos+20,10*nLine+4, "Toggle Bookmark", sdlwhite);
		else drawText(font,im_screen,menupos+20,10*nLine+4,"Toggle Bookmark", sdlblack);
		if (menucursor == 11) drawTextShadowed(font,im_screen, menupos+20,11*nLine+4, "Goto Bookmark", sdlwhite);
		else drawText(font,im_screen,menupos+20,11*nLine+4,"Goto Bookmark", sdlblack);			
	}
}

void getThemeInput(void)
{
	if (pad.Buttons & PSP_CTRL_UP) {
		if ((thselect + thscroll == 0) && thselect > 0) thscroll++;
		thselect--;
		if (thselect < 0) thselect = 0;
		thcursor--;
		if (thcursor < 0) thcursor = 0;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_DOWN) {
		if ((thselect + thscroll == thmaxlines-1) && thselect < themedir.size()-1) thscroll--;
		thselect++;
		if (thselect == themedir.size()) thselect = themedir.size()-1;
		thcursor++;
		if (thcursor == thmaxlines) thcursor = thmaxlines-1;
		
		if (thcursor == themedir.size()) thcursor = themedir.size()-1;

		wait = 100;
		bmUpdate = true;
	}
	
	if (pad.Buttons & PSP_CTRL_CROSS && !transition)
	{
		theme = themedir[thselect];
		saveSettings();
		load_gfx();
		bmUpdate = true;
	}
}

void displayTheme(void) 
{
	int count;
	string textscroll;
	
	blit(im_screen,0,0, img_background);
	drawMenuFrame(im_screen);
	//drawText(systemfont,im_screen,30,161,"Edit:         Delete:           New:        View:",sdlblack);
	//drawText(systemfont,im_screen,30,161,"      Square          Triangle       Cross        Circle",sdlblue);
	
	drawText(font,im_screen,198,17,"Change Theme", sdlblack);
	
	for (count = 0; count < 10; count++)
	{
		drawHline(im_screen, 35, 45 + count*nLine, 413, lightgrey);
	}
	for (count = 0; count < themedir.size(); count++) 
	{
		if (themedir[count].size() > 59) 
		{
			textscroll = themedir[count].substr(0,59);
		}
		else 
		{
			textscroll = themedir[count];
		}
		if (thselect == count) 
		{
			drawFillRect(im_screen,34,35+thcursor*nLine - 1, 1+textscroll.size() * nCol, nLine, grey);
		}
		if ((thscroll*nLine + count*nLine) < 120 && (thscroll*nLine + count*nLine) >= 0) 
		{
			drawText(font,im_screen,35,35+thscroll*nLine+count*nLine, textscroll, sdlblack);
		}
	}
}
