#include <pspkernel.h>
#include <pspdebug.h>
#include <pspiofilemgr.h>
#include <pspctrl.h>
#include <pspaudio.h>
#include <pspdisplay.h>
#include <pspaudiolib.h>
#include <pspthreadman.h>
#include <pspusb.h>
#include <pspusbstor.h>
#include <psputility.h>
#include <psploadexec.h>
#include <pspsdk.h>

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>
#include "sge.h"
#include "codec.h"
#include "codecincs.h"
#include "calc.hh"
#include "p_sprint.h"

#include "frontend.h"
#include "notepad.h"
#include "imageviewer.h"
#include "calendar.h"
#include "calculator.h"
#include "addressbook.h"
#include "clock.h"
#include "music.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <string>
#include <vector>
#include <stack>
#include <fstream>
#include <algorithm>
using namespace std;


#define FRONTEND 0
#define KEYBOARD 1
#define EDIT 2
#define FULLSCREEN 3
#define IMAGE 4
#define ADDRESSBOOK 5
#define CALCULATOR 6
#define CALENDAR 7

#define DIRECTORY 5
#define SELECTDIR 7
#define RENAME 13
#define DELETE 14
#define KEYBOARDSETTINGS 18
#define CLOCK 19
#define SETCLOCKMENU 20
#define WORLDCLOCK 21
#define STOPWATCH 22
#define TIMER 23
#define PLAYLIST 25
#define GOTOMONTH 26
#define WEEKEVENTS 27
#define MONTHEVENTS 28
#define THEME 29


class Dir
{
	public:
		string name;
		int isDir;
	
	private:
};


bool padLeft(void);
bool padRight(void);
bool padUp(void);
bool padDown(void);
string readKey(void);
void load_play(const char* file);
bool is_image(string file);
bool is_audio(string file);
bool is_exec(string file);
void readKeyboard(void);
void loadSettings(void);
void saveSettings(void);
void listThemeDirectory(vector <string> &themedir);
void listDirectory(string path);
void listAudioDirectory(string path, int flag);
int load_gfx(void);
void drawKeyboard(SDL_Surface *surface);
void drawText(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color);
void drawTextShadowed(TTF_Font* font,SDL_Surface* surface, int x, int y, string text, SDL_Color color);
void drawFillRect(SDL_Surface* surface, int x0,int y0, int w, int h, Uint32 color);
void drawHline(SDL_Surface* surface, int x0,int y0, int w, Uint32 color);
void drawVline(SDL_Surface* surface, int x0,int y0, int h, Uint32 color);
void drawRect(SDL_Surface* surface, int x0, int y0, int w, int h, Uint32 color);
void blit(SDL_Surface * Dest, Sint16 DestX, Sint16 DestY, SDL_Surface * Src);
void drawDropmenu(SDL_Surface* surface, int x0, int y0, int nChar, int nList);
void drawFrame(SDL_Surface* surface, int x0, int y0, int w, int h);
void drawMenuFrame(SDL_Surface* surface);
void set_colors(SDL_PixelFormat* format);
void setBounds(int fontsize);
void initTimezone(void);
#ifdef KERNEL
void loadUsbDrivers(void);
int execute(SceSize args, void *argp);
int SetupExecute(string prog);
#endif /*KERNEL*/

